<?php
/************************************************************************
    This file is part of Desk-Kregator.

    Desk-Kregator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Desk-Kregator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Desk-Kregator.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************/

// Cache must be writable
if( !is_writable('./system/cache/') ) {

$o->success = false;
$o->message = 'cache directory is not writable';
echo json_encode($o);
exit;

}


require_once("system/modules/Desk-Kregator/php/lib.php");

require_once("system/modules/Desk-Kregator/php/simplepie.inc.php");

$o = new stdClass;

if( isset($_POST['view']) && $_POST['view'] == 'on' ) {
 $view = 'site';
} else {
 $view = 'normal';
}


if( !isset($_POST['newFeed']) || trim($_POST['newFeed']) == '' ) {

$o->success = false;
$o->message = 'No Feed';
echo json_encode($o);
exit;

}

// Verify if cache dir exist for this user
if( !is_dir('./system/cache/memberID_'.$member_id) ) {

mkdir('./system/cache/memberID_'.$member_id);

}

$new_feed = trim($_POST['newFeed']);
$nodeID = trim($_GET['nodeID']);

$feed = new SimplePie();

if (get_magic_quotes_gpc()) {
   $new_feed = stripslashes($new_feed);
}
$feed->set_cache_location('./system/cache/memberID_'.$member_id);

$feed->set_feed_url($new_feed);

$feed->enable_order_by_date(false);
$feed->init();

$feed->handle_content_type();

if( $feed->error() ) {

$o->success = false;
$o->message = 'Bad url.';
echo json_encode($o);
exit;

}

// Add / at the end of url if needed
$url_site = $feed->get_link();
if( substr($url_site, -1, 1) != '/' ) $url_site = $url_site.'/';


/* Put in cache favicon & img of this site */

// Favicon
$tmp_fav = $feed->get_favicon();

if( $tmp_fav != '' ) {

  if( substr($feed->get_favicon(), 0, 7) != 'http://' ) $tmp_fav = $url_site.$feed->get_favicon();

  $part = explode('/',$tmp_fav);
  $fav_name = 'fav_'.sha1($new_feed).'_'.$part[count($part)-1];

  if( !@copy($tmp_fav, './system/cache/memberID_'.$member_id.'/'.$fav_name) ) {

    $favicon = $tmp_fav;

  } else {

    $favicon = './system/cache/memberID_'.$member_id.'/'.$fav_name;

  }

} else $favicon = '';


// Image descriptive
$tmp_image = $feed->get_image_url();

if( $tmp_image != '' ) {

  $part = explode('/',$tmp_image);
  $img_name = 'img_'.sha1($new_feed).'_'.$part[count($part)-1];

  if( !@copy($tmp_image, './system/cache/memberID_'.$member_id.'/'.$img_name) ) {

    $img_desc = $tmp_image;

  } else {

    $img_desc = './system/cache/memberID_'.$member_id.'/'.$img_name;

  }

} else $img_desc = '';

// Insert feed
$s = '
INSERT INTO
deskKregator_dir

(type, name, description, url, url_feed, image, favicon, node, display_order, view, userID)
VALUES (
\'file\',
\''.mysql_real_escape_string($feed->get_title()).'\',
\''.mysql_real_escape_string($feed->get_description()).'\',
\''.$url_site.'\',
\''.$new_feed.'\',
\''.$img_desc.'\',
\''.$favicon.'\',
\''.$nodeID.'\',
\'0\',
\''.$view.'\',
\''.$member_id.'\'
)';

if( !mysql_query($s) ) {

$o->success = false;
$o->message = 'Error while adding new feed. Sql error : '.mysql_error();
echo json_encode($o);
exit;

}

$id_feed = mysql_insert_id();

// Insert elements

if ($feed->data):
  $items = $feed->get_items();
  foreach($items as $item):

$auteur_1 = $item->get_author();

if( !isset( $auteur_1 ) ) $auteur = '-';
else $auteur = $auteur_1->get_name();

// images relatives
$contenu = $item->get_content();
$contenu = str_replace('src="/', 'src="'.$feed->get_link(), $contenu);

// Enclosure management

$enclosures = $item->get_enclosures();

$nb_enclosures = count($enclosures);
$nb_real_enclosures = 0;
$enclosure_contenu = '';

if( $nb_enclosures > 0 ) {

$enclosure_contenu .= '<h1 class="DeskKregator-enclosure">Media</h1><table>';

foreach($enclosures as $enclosure) {

$extension = strtolower(substr($enclosure->link, -3));

if( $enclosure->handler == 'mp3' && $extension == 'mp3' ) {

  $nb_real_enclosures++;
  $enclosure_contenu .= get_enclosure('mp3', $enclosure->link, 0, 0, $enclosure->title);

} else if( $enclosure->handler == 'fmedia' && $extension == 'flv'  ) {

  $nb_real_enclosures++;
  $enclosure_contenu .= get_enclosure('flv', $enclosure->link, $enclosure->height, $enclosure->width, $enclosure->title);

} else if ( $enclosure->type == 'application/pdf' ) {

  $nb_real_enclosures++;
  $enclosure_contenu .= get_enclosure('pdf', $enclosure->link, 0, 0, $enclosure->title, $enclosure->type);

} else if ( $enclosure->type != 'application/postscript'
         && $enclosure->type != 'image/gif'
         && $enclosure->type != 'image/png'
         && $enclosure->type != 'image/jpeg'
         && $enclosure->type != 'image/bmp' ) {

  $nb_real_enclosures++;
  $enclosure_contenu .= get_enclosure('other', $enclosure->link, $enclosure->height, $enclosure->width, $enclosure->title, $enclosure->type);

}
} // End foreach

$enclosure_contenu .= '</table>';

} // There is an enclosure

// Add enclosure
if( $nb_real_enclosures != 0 ) {
$contenu = $contenu.$enclosure_contenu;
}

$s = '
INSERT INTO
deskKregator_items

(id_feed, titre, date, auteur, summary, description, url, userID)
VALUES (
\''.$id_feed.'\',
\''.mysql_real_escape_string($item->get_title()).'\',
\''.$item->get_date('Y-m-d H:i:s').'\',
\''.mysql_real_escape_string($auteur).'\',
\''.summary(mysql_real_escape_string($contenu), '100').'\',
\''.mysql_real_escape_string($contenu).'\',
\''.$item->get_permalink().'\',
\''.$member_id.'\'
)';

if( !mysql_query($s)) {

$o->success = false;
$o->message = 'Error while inserting articles. Sql error : '.mysql_error();
echo json_encode($o);
exit;

}

  endforeach;
endif;


$unseen = get_unseen($id_feed, $member_id);

if( $unseen != 0 ) {

 $cls = 'file DeskKregator-feed-Unseen';

} else {
 $cls = 'file';
}

$o->success = true;

$o->text = $feed->get_title();
$o->id = $id_feed;
$o->url = $url_site;
$o->url_feed = $new_feed;

$o->cls = $cls;
$o->unseen = $unseen;
$o->total = get_total($id_feed, $member_id);
$o->type = 'file';
$o->desc = $feed->get_description();
$o->image = $img_desc;
$o->icon = $favicon;
$o->view = $view;
$o->nodeID = $nodeID;

echo json_encode($o);
exit;

?>